﻿@page "/contacttype"
@using VacationSchedule.Core.Models.DB
@inject HttpClient Http

<PageTitle>Типы Контактов</PageTitle>

<h1>Типы Контактов</h1>

@if (contactTypes == null)
{
    <p><em>Loading...</em></p>
}
else
{
    <table class="table">
        <thead>
            <tr>
                <th>Тип</th>
                <th>Действия</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var contact in contactTypes)
            {
                <tr>
                    <td>@contact.Name</td>
                    <td></td>
                </tr>
            }
            <tr>
                <td>
                    <input type="text" class="form-control" placeholder="Контакт" @bind="newContactType.Name" />
                </td>
                <td>
                    <button class="btn btn-primary" @onclick="@(e => AddContact(newContactType))">Add</button>
                </td>
            </tr>
        </tbody>
    </table>
}

@code {
    private ContactType[] contactTypes;
    private ContactType newContactType;

    protected override async Task OnInitializedAsync()
    {
        await RefreshContacts();
    }

    private async Task RefreshContacts()
    {
        contactTypes = await Http.GetFromJsonAsync<ContactType[]>($"api/ContactType");
        newContactType = NewContact();
    }

    private async Task AddContact(ContactType contact)
    {
        await Http.PostAsJsonAsync<ContactType>($"api/ContactType", contact);
        await RefreshContacts();
    }

    private ContactType NewContact() => new();
}